<?php
////////////////////////////////////////////////////////
//PHP-Nuke 6.5 -> Drupal 5.x Migrator                 //
////////////////////////////////////////////////////////
//  (modified from a nuke 6.7->drupal 4.7 migrator)   //
//August 19th, 2007                                   //
//If you have questions or bug reports contact me via://
//http://www.quillem.com/nuke2drupal                  //
//Kartformathik Kumar                                 //
//Modifications by:                                   //
//Alexis Bellido <alexis@ventanazul.com>              //
////////////////////////////////////////////////////////

// Slight modifications by:
// Bogdan Tokovenko
// http://bogdan.org.ua/2006/09/08/php-nuke-60-to-drupal-473-migration-conversion.html
// http://bogdan.org.ua/contact/
// * added options for custom phpnuke table prefixes
// * default name is now = uname (login), not 'temp_name'
// * replaced links to 'migrate.php' with links to $_SERVER['PHP_SELF']
// * now forum topics should not be promoted to the main page (changed 1 to 0 as hinted by Alexis)
// * added several detailed MySQL debug messages

// More modifications by Waldo  [user "VValdo" on drupal.org] - Feb-24-07
// New Features:
//   migrates from (a security-patched) Nuke 6.5 -> Drupal 5.1
//   migrates story categories into Drupal taxonomy.
//   incorporates phpnuke "Informer writes..." into story  (assumes informer is not a drupal user as can't verify in PHP-Nuke)
//   incorporates phpnuke admin story "notes"
//   migrates polls (does not import record of who already voted.  You can easily "close" old phpnuke polls via Admin page.  I left them open)
//   migrates poll comments
//   migrates anonymous comments for stories, fora, & polls
//   migrates anonymous forum posts
//   filters BBCode to make semi-compatible with Drupal BBCode module
//   New features use Drupal 5 API somewhat. (As a result, must be run from drupal root directory (/drupal-5/, for example))
//   ...and oh-so-much-more!
//
// New Fixes from Waldo
//   * retain original user registration date & last visit   4/22/07
//   * fixed user migration bug which could result in screwed max_uid in session table   4/22/07
//   * Store anonymous forum posts names in the log for future compatibility w/Drupal 6   7/16/07
//   * Uses the "tidy" extension (if installed) in php 5.x to clean up the HTML of postings & stories  7/30/07
//   * Bug fixes (possibly) related to drupal 5.2 where the fora had the wrong "changed" date resulting in misordered node lists. 7/30/07
//   * Polls properly remember date of last comment 7/30/07
//
// Note:  As of Drupal 5.x, migrating other phpnuke features like "Reviews" requires creating special node types with custom fields,
//        which can be done w/ drupal's community-contributed "CCK" module.
//        Once you create your custom nodes, you will then need to further modify this script.  Good luck!

/*  Copyright 2006-2007 by the above contributors

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; version 2 of the License.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

//bootstrap drupal
if (!file_exists("./includes/bootstrap.inc")) {echo "This migration script uses the Drupal 5 API and must be run from the drupal root directory.  Move the file and try again."; exit;}

require_once './includes/bootstrap.inc';
drupal_bootstrap(DRUPAL_BOOTSTRAP_FULL);


	error_reporting(E_ALL);
	ini_set('display_errors', true);
	ini_set('html_errors', true);
	ini_set('max_execution_time', '3600');
	// if you have problems with timeouts, adjust the above as well as php.ini in your php configuration
	/////////////////////////////////////

	$version = "5.x-0.03-W";
	
	//This is what you edit.

	//Database config 
	$host = "localhost"; //Host address for MySQL
	$username = "root"; //Username to connect to MySQL
	$password = ""; //Password to connect to MySQL
	$nuke = "nuke"; //Name of the Nuke database
	$drupal = "drupal"; //Name of the Drupal database

       // PHPNuke database tables prefixes
	$nuke_prefix = "nuke"; //Prefix used for PHPNuke tables
	$nuke_secret = "nuke"; // 'Secret' prefix used for PHPNuke 'users' table

	//Users already added to Drupal [anonymous should always be present]
	$user_array = array("anonymous", "admin", "waldo");

	/////////////////////////////////////
	//You shouldn't have to modify anything below this.
	
	
	//Tables
	$n_users = "{$nuke}.{$nuke_secret}_users";
	$n_stories = "{$nuke}.{$nuke_prefix}_stories";
	$n_fora = "{$nuke}.{$nuke_prefix}_bbforums";
	$n_posts = "{$nuke}.{$nuke_prefix}_bbposts";
	$n_posts_text = "{$nuke}.{$nuke_prefix}_bbposts_text";
	$n_storytopics = "{$nuke}.{$nuke_prefix}_topics";
	$n_topics = "{$nuke}.{$nuke_prefix}_bbtopics";
	$n_comments = "{$nuke}.{$nuke_prefix}_comments";
	$n_pollcomments= "{$nuke}.{$nuke_prefix}_pollcomments";
	$n_poll_check="{$nuke}.{$nuke_prefix}_poll_check";
	$n_poll_data="{$nuke}.{$nuke_prefix}_poll_data";
	$n_poll_desc="{$nuke}.{$nuke_prefix}_poll_desc";

	$d_users = $drupal.".users";
	$d_roles = $drupal.".users_roles";
	$d_nodes = $drupal.".node";
	$d_nodes_revisions = $drupal.".node_revisions";
	$d_sequences = $drupal.".sequences";
	$d_fora = $drupal.".forum";
	$d_comments = $drupal.".comments";
	$d_comment_statistics = $drupal.".node_comment_statistics";
	$d_term_data = $drupal.".term_data";
	$d_term_node = $drupal.".term_node";
	$d_term_hierarchy = $drupal.".term_hierarchy";
	$d_variables = $drupal.".variable";
	$d_vocabulary = $drupal.".vocabulary";
	$d_vnodestypes = $drupal.".vocabulary_node_types";
	$d_poll = $drupal.".poll";
	$d_poll_choices= $drupal.".poll_choices";
	$d_poll_votes = $drupal.".poll_votes";

	$role_string = 'a:1:{s:5:"roles";a:1:{i:0;s:1:"2";}}';
	$comment_user_string = 'a:1:{i:0;i:0;}';
	
	//Story HTML format - 
	//1 = Filtered HTML 2 = PHP Allowed 3 = All HTML (3 - recommended)
	// note:  Be sure you turn on the BBCode module for $forum_format, whichever type you choose.
	$format = 1;
	$forum_format=1;
	$poll_format=0;

	// some "constants"
	$promote = 1;
	$comment = 2;
	$node_stype = "story";
	$node_ftype = "forum";
	$node_ptype = "poll";

	$forum_container = "Archived Nuke Fora";
	$container_description = "Nuke Fora transferred to drupal. Will need to be reorganised.";


	/////////////////////////////////
	//Functions
	//Gets the vid for a field (forums) from the vocabulary table
	
	function get_vid($name)
	{
		//message("Getting current vid for $name");
		$d_vocabulary = $GLOBALS["d_vocabulary"];
		$query = "SELECT vid FROM $d_vocabulary where name='$name'";
		$result = mysql_query($query);
		if ($row = mysql_fetch_object($result))
		{
			//success("vid for $name retrieved!");
			return($row->vid);
		}
		else
		{
			failure("MySQL Error: vid for $name could not be retrieved");
			echo " Query used to get vid for $name: $query ; \n";
			echo " Error returned by MySQL: (" . mysql_errno() . ") " . mysql_error() . " \n";
			exit();
		}
	}
	
	//Gets the max_id from the sequences table for a particular id.
	//This is because the tables don't/shouldn't really use the auto_increment featureof MySQL/pgSQL
	//as it is not ANSI compliant. So Drupal stores the next auto_increment value in a separate table.
	function get_max_id($field)
	{
		//message("Getting Max ID for $field");
		$d_sequences = $GLOBALS["d_sequences"];
		$query = "SELECT id FROM $d_sequences WHERE name='$field'";
		$result = mysql_query($query);
		if ($row = mysql_fetch_object($result))
		{
			//success("Max ID for $field retrieved!");
			return($row->id);
		}
		else
		{
			failure("MySQL Error: Max ID for $field could not be retrieved");
			echo " Query used to get the Max ID: $query ; \n";
			echo " Error returned by MySQL: (" . mysql_errno() . ") " . mysql_error() . " \n";
			exit();
		}
	}
	
	//Updates the above mentioned field once a row(s) is inserted.
	function set_max_id($field, $value)
	{
		//message("Updating Max ID for $field");
		$d_sequences = $GLOBALS["d_sequences"];
		$query = "UPDATE $d_sequences SET id='$value' WHERE name='$field'";
		$result = mysql_query($query);
		if (!$result)
		{
			failure("MySQL Error: Max ID for $field could not be updated");
			echo " Query used to update Max ID for $field: $query ; \n";
			echo " Error returned by MySQL: (" . mysql_errno() . ") " . mysql_error() . " \n";
			exit();
		}
		//success("Max ID for $field updated!");
	}

	// may fix some bad web urls from nuke
	function fixurl($url)
	{
	
		if ((strlen($url) == 0) || (strncasecmp ( $url, "http://", 7) == 0))
		{ return($url); }
		   else
		{return ($temp = "http://" . $url);}
	}
	
	//Convert Hex IP to standard octet form
	function get_ip($hexip)
	{
		$ip = array();
		for ($i = 0; $i < 4; $i++)
		{
			$octal = substr($hexip, $i * 2, 2);
			$ip[$i] = hexdec($octal);
		}
		return(implode(".", $ip));
		}
		
	// Display functions
	// Displays page headings
	function mainheading($str)
	{
		echo "<h3>$str</h3>";
	}
	function heading($str)
	{
		echo "<h4>$str:</h4>";
	}
	function message($str)
	{
		echo "<div class='message'>$str</div>";
	}
	function success($str)
	{
		echo "<div class='success'>$str</div>";
	}
	function failure($str)
	{
		echo "<div class='failure'>$str</div>";
		echo "<div class='options'>";
		echo "&nbsp;<a href='{$_SERVER['PHP_SELF']}'>Back To Main?</a>";
		echo "</div>";
	}
	//Connect to MySQL
	$connected = true;
	$link = @mysql_connect($host, $username, $password);
	if (!$link)
	{
		failure("Connection to MySQL could not be made. Edit this file and make sure that the database settings are correct.");
		echo " Error returned by MySQL (if any): (" . mysql_errno() . ") " . mysql_error() . " \n";
		$connected = false;
		if (isset($_GET["section"]))
		{
			exit();
		}
	}
	
	// if you have php5 and the "tidy" module, this will clean up user text for you.
	function tidyhtml($str)
	{

		if (extension_loaded("tidy")) {  // Tidy is installed, so make sure this html snippet is kosher. --W
		
		$config = array(
			'logical-emphasis' => true,
			'DocType' => 'omit',
			'drop-empty-paras' => false,
			'indent'         => true,
			'wrap'          => 0,
			'output-html'   => true,
			'char-encoding' => 'utf8',
			'input-encoding' => 'latin1',  // change as necessary.  most older mysql DBs are latin1
			'output-encoding' => 'utf8',
			'hide-endtags' => true,
			'replace-color' => true,
			'show-body-only' => true);

		$tidy = new tidy;
		$tidy->parseString($str, $config, 'utf8');
		$tidy->cleanRepair();
		return tidy_get_output($tidy);
		}
		else {
		return $str; }		
		
	}
	
	////////////////////////////////
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
		<title>Nuke Migrator</title>
		<style type="text/css">
			body
			{
				margin: 0px;
				padding: 0px;
				background-color:#FCFCFC;
			}
			.container
			{
				margin:1em;
				padding:0.5em;
				border:1px dashed #AAAAAA;
			}
			.container ul
			{
				margin:0;
			}
			h3
			{
				color:#000099;
				padding:0.5em;
				padding-top:0;
				padding-bottom:0.2em;
				margin-top:1em;
				margin-bottom:0;
			}
			h4
			{
				margin:0;
				color:#993333;
				padding-bottom:1em;
				text-transform:capitalize;
				font-variant:small-caps;
			}
			.options
			{
				margin:1em;
				border-top:1px dashed #CCCCCC;
				text-align:right;
			}
			.important
			{
				color:#FF0000;
			}
			.message, .success, .failure
			{
				margin-bottom:0.5em;
				padding:0.2em;
				padding-left:0.7em;
			}
			.message
			{
				background-color:#CCCCCC;
			}
			.success
			{
				background-color:#90CC90;
			}
			.failure
			{
				background-color:#FF9999;
			}
		</style>
	</head>
	<body>
		<?php 
			mainheading("Nuke &rsaquo;&rsaquo; Drupal Migrator");
		?>
		<div class="container">
			<?php
				$section = (isset($_GET["section"]))?$_GET["section"]:"";
				switch ($section)
				{


					case "polls":
						heading("Migrating polls...");
						message("Note:  Polls & their comments will be migrated, but a list of who's already voted will not.");
						message("You can make migrated polls \"inactive\" from within Drupal if you want to turn off voting.");

						$query = "SELECT $n_poll_desc.pollTitle AS title, $n_poll_desc.pollID, $n_poll_desc.timestamp AS time ";
						$query .= "FROM $n_poll_desc WHERE $n_poll_desc.pollID > 0";
						
						echo $query;
						$result = mysql_query($query, $link);
						if ($result)
						{
							success("Sucessfully loaded polls");
						}
						else
						{
							failure("Could not load polls");
							exit();
						}
						
						while ($row = mysql_fetch_object($result))  {
							
							// get the vote's choices
							$query2 = "SELECT  $n_poll_data.optionText, $n_poll_data.optionCount, $n_poll_data.voteID ";
							$query2 .= "FROM $n_poll_data WHERE $n_poll_data.pollID = $row->pollID";
						
							echo $query2;
							$result2 = mysql_query($query2, $link);
							if ($result2)
							{
								success("Sucessfully loaded poll choices");
							}
							else
							{
								failure("Could not load poll choices");
								exit();
							}
							unset($choices);
							while ($row2 = mysql_fetch_object($result2))  {
								$choices[] = array(
									'chid' => $row2->voteID-1,
									'chvotes' => $row2->optionCount,
									'chtext' => $row2->optionText);
							}
							
					//	don't need this cuz using Drupal 5 API		
					//	while ($row2 = mysql_fetch_object($result2))  { if (strlen($row2->optionText) !=0) { $choices .= '* '. addslashes($row2->optionText) .'\n';} }
					
						// echo $choices;
						unset($mynode);
						$mynode = new StdClass;

						$mynode->title = $row->title;
						$mynode->type=$node_ptype;
						$mynode->uid = 1;  //phpnuke doesn't have poll owners.  We'll make user #1 the owner (make 0 to be anonymous)
						$mynode->status=1;
						$mynode->created = $row->time;
						$mynode->changed = $row->time;
						$mynode->comment=$comment;
						$mynode->promote=1;
						$mynode->choice =  $choices;
						$mynode->teaser = poll_teaser($mynode);
						$mynode->timestamp = $row->time;
						$mynode->format = $poll_format;
						print_r($mynode);
						
						node_save($mynode);

						if ($nid=$mynode->nid) { message("Poll node # $mynode->nid created.");} else {failure("Error inserting forum node $mynode->nid:");exit;}
						$mynode->nid = $nid;
						//poll_insert($mynode);

						// now add the voting comments...
						
							$pollID = $row->pollID;
							$query3  = "select $n_pollcomments.comment, $n_pollcomments.tid, $n_pollcomments.pid, $n_pollcomments.date,  $n_pollcomments.subject, ";
							$query3 .= "$n_pollcomments.name, $n_pollcomments.email, $n_pollcomments.url, $n_pollcomments.host_name ";
							$query3 .= "FROM $n_pollcomments WHERE $n_pollcomments.pollID = $pollID order by $n_pollcomments.date";
							
							echo $query3;
							$result3 = mysql_query($query3, $link);
							if (!$result3) {
							  failure("couldn't get poll comments for pollID=$pollID");
							  exit();
							}
							
							// clear out the map
							unset($commap);
							
							while ($thiscomment = mysql_fetch_object($result3)) {
							
							$myuser['name']=$thiscomment->name;
							if ($commentor = user_load($myuser)) { $myuid=$commentor->uid;} else {$myuid=0;}
							
							
							if ($thiscomment->pid == 0) {$mypid=0;}
							   else {$mypid = $commap[$thiscomment->pid];}
							
							echo "mypid = $mypid<br>";
							if ($myuid == 0) {$user->name = $thiscomment->name;}  // for anonymous users -W

							$mycomment['pid']=$mypid;
							$mycomment['uid']=$myuid;
							$mycomment['nid']=$nid;
							$mycomment['name'] = $thiscomment->name;
							$mycomment['subject'] = $thiscomment->subject;
							$mycomment['comment'] = $thiscomment->comment;
							$mycomment['mail'] = $thiscomment->email;
							$mycomment['homepage'] = fixurl($thiscomment->url);
							$mycomment['hostname'] = $thiscomment->host_name;
							// print_r($mycomment);
							echo "<p>saving comment from " . $thiscomment->name . " called " . $thiscomment->subject;
							
							// drupal will insert the current date.  We want the original date.  Fix that. --Waldo
							if ($comid = comment_save($mycomment)) { $query4 = "UPDATE $d_comments SET timestamp = " . strtotime($thiscomment->date) . ", hostname = '" .  $thiscomment->host_name . "' WHERE cid=$comid"; echo $query4; $result4=mysql_query($query4, $link);

							
							
// drupal will insert the current date as the changed date as as the last comment made in the NODE and comment statistics.  We want the original date.  Fix that. --Waldo
$query4 = "UPDATE $d_nodes SET changed = " . strtotime($thiscomment->date) . " WHERE nid=$nid"; echo $query4;  $result4=mysql_query($query4, $link); 
$query4 = "UPDATE $d_comment_statistics SET last_comment_timestamp = " . strtotime($thiscomment->date) . " WHERE nid=$nid"; echo $query4; $result4=mysql_query($query4, $link);	
								
								
							// build the map to map old comment ids to new ones
							$commap[$thiscomment->tid] = $comid;
							}
							}

						
						}

						success("Polls and their comments transferred successfully!");
						echo "<div class='options'>";
						echo "&nbsp;<a href='{$_SERVER['PHP_SELF']}'>Back To Main?</a>";
						echo "</div>";

					break;

//////////////////////////////////////////////////////////////////////////////////////////

					case "users":
						heading("Migrating users");
						message("Giving blank user names a default value (their login)");
						$query = "UPDATE $n_users set name=username where name=''";
						// alexis
						echo $query;
						$result = mysql_query($query, $link);
						if ($result)
						{
							success("Default values set..(".mysql_affected_rows()." rows affected)");
						}
						else
						{
							failure("Default values could not be set");
							exit();
						}
						$maxuid = get_max_id("users_uid");
						message("Transferring User Details to Drupal..");
						$query = "INSERT into $d_users(uid, name, pass, mail, created, access, status, init, data) ";
						$query .= "SELECT @a:= $maxuid + 1 + user_id, username, user_password, user_email, UNIX_TIMESTAMP(STR_TO_DATE(user_regdate, '%b %d, %Y')), user_lastvisit, 1, user_email, '$role_string' ";
						$query .= "FROM $n_users ";
						$query .= "WHERE 1=1 ";
						for ($i = 0; $i < count($user_array); $i++)
							{
								$query .= "AND username != '$user_array[$i]' ";
							}
						// alexis
						echo $query;
						$result = mysql_query($query, $link);
						if ($result)
						{
							$newusers = mysql_affected_rows();
							success("Users Added..(".$newusers." rows affected)");
							$query = "select max(uid) from $d_users";
							$result = mysql_query($query, $link);
							$maxuser = mysql_fetch_row($result);
							set_max_id("users_uid", $maxuser[0]);
							// set_max_id("users_uid", $maxuid + $newusers);
							$query = "insert into $d_roles(uid, rid) ";
							$query .= "SELECT uid, 2 AS rid ";
							$query .= "FROM $d_users ";
							$query .= "WHERE uid > $maxuid ";
						        // alexis
						        echo $query;
							$result = mysql_query($query, $link);
							if ($result)
							{
								success("User roles updated - all users registered as authenticated users (role = 2).");
							}
							else
							{
								failure("Users Roles could not be added. It could be that there are duplicate usernames that are causing conflicts.");
								exit();
							}
						}
						else
						{
							failure("Users could not be added.");
							exit();
						}
						echo "<div class='options'>";
						echo "<a href='{$_SERVER['PHP_SELF']}?section=stories'>Migrate Stories?</a>";
						echo "&nbsp;<a href='{$_SERVER['PHP_SELF']}'>Back To Main?</a>";
						echo "</div>";
						break;


//////////////////////////////////////////////////////////////////////////////////////////


					case "stories":
						heading ("Migrating story Categories");
						$maxvocadvid = get_max_id("vocabulary_vid");
						$termdatatid = get_max_id("term_data_tid");
						$query="SELECT $n_storytopics.topictext FROM $n_storytopics WHERE $n_storytopics.topicid > 1";
						echo $query;
						$result = mysql_query($query, $link);
						if ($result)
						{
							success("Retrieved Categories From Nuke");
							$vocadvid = $maxvocadvid+1;
							$termdatatid++;

				$query2 = "INSERT INTO $d_vocabulary(vid, name, description, help, relations, hierarchy, multiple, required, tags, module,weight) ";
				$query2 .= "VALUES ($vocadvid, '$node_stype topic', '', '', 0, 0, 0, 1, 0, 'taxonomy', 0)";
				echo $query2;
				$result2 = mysql_query($query2, $link);

				if (!$result2) {
 					 failure("Error adding line to $d_vocabulary");
 					 exit();  }

				$query2 = "INSERT INTO $d_vnodestypes(vid, type) ";
				$query2 .= "VALUES ($vocadvid, '$node_stype')";
				echo $query2;
				$result2 = mysql_query($query2, $link);

				if (!$result2) {
 					 failure("Error adding line to $d_vnodestypes");
 					 exit();  }
					 

							while ($row = mysql_fetch_object($result))
							{
								$query2 = "INSERT INTO $d_term_data(tid, vid,name, description, weight) ";
								$query2 .= "VALUES ($termdatatid, $vocadvid, '$row->topictext', '',0)";
								echo $query2;
								$result2 = mysql_query($query2, $link);

								if (!$result2) {
									failure("Error adding category:  $row->topictext");
									exit();  }

								$query2 = "INSERT INTO $d_term_hierarchy(tid, parent) ";
								$query2 .= "VALUES ($termdatatid,0)";
								echo $query2;
								$result2 = mysql_query($query2, $link);

								if (!$result2) {
									failure("Error adding category:  $row->topictext");
								exit();  }

								$catarray[$row->topictext] = $termdatatid;  //build an array to find the categories later
								//$vocadvid++;
								$termdatatid++;
							}
							set_max_id("vocabulary_vid",$maxvocadvid +1);
							set_max_id("term_data_tid",($termdatatid-1));

							success("Story catagories imported.");

						}
						else {
							 failure("Error getting categories from Nuke");
  							exit();
						}

						heading("Migrating Stories");
						$maxnid = get_max_id("node_nid");

						$query = "SELECT $d_users.uid, $n_stories.title, $n_stories.topic, UNIX_TIMESTAMP($n_stories.time) AS time, $n_stories.hometext, ";
						$query .= "$n_stories.bodytext, $n_stories.sid AS storysid, $n_stories.notes, $n_stories.informant, $n_stories.aid ";
						$query .= "FROM $n_stories, $d_users ";
						$query .= "WHERE $n_stories.aid=$d_users.name OR ($n_stories.aid='anonymous' AND $d_users.uid=0)";
						message("Retrieving stories from PHP-Nuke");
						// alexis
						echo $query;
						$result = mysql_query($query, $link);
						if ($result)
						{
							success("Retrieved Stories From Nuke");
							message("Adding retrieved stories into Drupal. This may take a while..");
							$nid = $maxnid + 1;
							while ($row = mysql_fetch_object($result))
							{
								// let's start by adding informant & admin notes to the story.
								
								if ((strcmp($row->informant,'') !=0) && (strcmp($row->informant,$row->aid) !=0))
									{
									// $row->hometext = mb_convert_encoding($row->hometext,"UTF-8","ISO-8859-1");  // may fix some character issues w/old MySQL dbs -W
									$row->hometext = $row->informant . " writes, \"<cite>" . $row->hometext . "</cite>\"";}
								if (strcmp($row->notes,'') !=0) { $row->hometext .= "\n\n<p />".$row->notes;}
								$row->hometext = addslashes(tidyhtml($row->hometext));
								$row->bodytext = addslashes(tidyhtml($row->bodytext));
								$row->title = addslashes($row->title);

								$tid = $row->topic;
								$query ="SELECT $n_storytopics.topictext FROM $n_storytopics WHERE $n_storytopics.topicid = $row->topic";
								echo $query;
								$result2 = mysql_query($query, $link);
								if (!$result2) {
									failure("Error finding story topics.");
									exit();
								}
								$thiscat = mysql_fetch_object($result2);
								$query ="INSERT INTO $d_term_node (nid, tid) VALUES ($nid,'".$catarray[$thiscat->topictext]."')";
								echo $query;
								$result2 = mysql_query($query, $link);
								if (!$result2) {
									failure("Error inserting into hierarchy.");
									exit();
								}


$query = "INSERT INTO $d_nodes(nid, vid, type, title, uid, status, created, changed, comment, promote) ";
$query .= "VALUES ('$nid', '$nid', '$node_stype', '$row->title', '$row->uid', 1, '$row->time', '$row->time', '$comment', '$promote')";

$query_revisions = "INSERT INTO $d_nodes_revisions(nid, vid, uid, title, teaser, body, log, timestamp, format) ";
$query_revisions .= "VALUES ('$nid', '$nid', '$row->uid', '$row->title', '$row->hometext', '".$row->hometext."<p>".$row->bodytext."</p>"."', '', '$row->time', '$format')";

// alexis
echo $query . '<br>';
echo $query_revisions . '<br>';

$result2 = mysql_query($query, $link);

if (!$result2) {
  failure("Error transferring story '$row->title'. ".($nid - $maxnid - 1)." stories transferred");
  exit();
} else {
  //success("Story '$title' inserted");
}

$result3 = mysql_query($query_revisions, $link);

if (!$result3) {
  failure("Error transferring story '$row->title'. ".($nid - $maxnid - 1)." stories transferred");
  exit();
} else {
  //success("Story '$title' inserted");
}

//message("Inserting row into comment statistics table");
$query = "INSERT INTO $d_comment_statistics(nid, last_comment_timestamp, last_comment_uid, comment_count) ";
$query .= "VALUES ('$nid', '$row->time', '$row->uid', '0')";
// alexis
echo $query;
$result2 = mysql_query($query, $link);
if (!$result2) {
  failure("Post comments statistics registration failed");
  exit();
} else {
  //success("Story '$title' comment statistics inserted");

}

// now let's do the comments...  --Waldo


$storysid = $row->storysid;
$query3 = "select $n_comments.comment, $n_comments.tid, $n_comments.pid, $n_comments.date,  $n_comments.subject, $n_comments.name, $n_comments.email, $n_comments.url, $n_comments.host_name from $n_comments WHERE $n_comments.sid = $storysid order by $n_comments.date";

echo $query3;
$result3 = mysql_query($query3, $link);
if (!$result3) {
  failure("Post comments statistics registration failed");
  exit();
}

// clear out the map
unset($commap);

while ($thiscomment = mysql_fetch_object($result3)) {

$myuser['name']=$thiscomment->name;
if ($commentor = user_load($myuser)) { $myuid=$commentor->uid;} else {$myuid=0;}


if ($thiscomment->pid == 0) {$mypid=0;}
   else {$mypid = $commap[$thiscomment->pid];}

echo "mypid = $mypid<br>";
if ($myuid == 0) {$user->name = $thiscomment->name;}  // for anonymous users -W

$mycomment['pid']=$mypid;
$mycomment['uid']=$myuid;
$mycomment['nid']=$nid;
$mycomment['name'] = $thiscomment->name;
$mycomment['subject'] = $thiscomment->subject;
$mycomment['comment'] = tidyhtml($thiscomment->comment);
$mycomment['timestamp'] = strtotime($thiscomment->date);
$mycomment['mail'] = $thiscomment->email;
$mycomment['homepage'] = fixurl($thiscomment->url);
$mycomment['hostname'] = $thiscomment->host_name;
print_r($mycomment);
echo "<p>saving comment from " . $thiscomment->name . " called " . $thiscomment->subject;

// drupal will insert the current date and hostname.  We want the original date/host.  Fix that. --Waldo
if ($comid = comment_save($mycomment)) { $query4 = "UPDATE $d_comments SET timestamp = " . strtotime($thiscomment->date) . ", hostname = '" .  $thiscomment->host_name . "' WHERE cid=$comid"; echo $query4; $result4=mysql_query($query4, $link);

// build the map to map old comment ids to new ones
$commap[$thiscomment->tid] = $comid;
}
}

set_max_id("node_nid", $nid);
set_max_id("node_revisions_vid", $nid);  //added by Waldo  Make it update these two nodes every time, to facilitate testing.  Means many more queries but I don't care.  This is a 1x script.  Next time, I'll use Drupal API.

$nid++;
}

success(($nid - $maxnid - 1)." Stories transferred successfully!");
} else {
  failure("MySQL error. Nuke Stories could not be retrieved.");
  exit();
}
echo "<div class='options'>";
echo "<a href='{$_SERVER['PHP_SELF']}?section=fora'>Migrate Fora?</a>";
echo "&nbsp;<a href='{$_SERVER['PHP_SELF']}'>Back To Main?</a>";
echo "</div>";
break;


//////////////////////////////////////////////////////////////////////////////////////////



					case "fora":
						heading("Migrating Fora");
						$maxtid = get_max_id("term_data_tid");
						$vid = get_vid("Forums");
						$maxtid++;
						//archive_id : To set parent forum later on
						$archive_id = $maxtid;
						$query = "INSERT INTO $d_term_data(tid, vid, name, description) ";
						$query .= "VALUES ('$maxtid', '$vid', '$forum_container', '$container_description')";
						// alexis
						echo $query;
						//Insert Archive forum
						message("Insert Archive forum");
						$result = mysql_query($query, $link);
						if (!$result)
						{
							failure("Could not create Parent Forum.");
							exit();
						}
						success("Parent Forum Added");
						//////////////////////////////
						//Insert Archive Forum information into hierarchy table with parent as root (0)
						$query = "INSERT INTO $d_term_hierarchy(tid, parent) ";
						$query .= "VALUES ('$maxtid', '0')";
						// alexis
						echo $query . '<br>';
						message("Insert Archive Forum information into hierarchy table with parent as root (0)");
						$result = mysql_query($query, $link);
						if (!$result)
						{
							exit("Could not set container hierarchy.");
						}
						success("Parent Forum Hierarchy Established");
						//Copy forum names and descriptions over to drupal from nuke
						$query = "SELECT forum_id, forum_name, forum_desc FROM $n_fora";
						message("Copy forum names and descriptions over to Drupal from Nuke");
						$result = mysql_query($query, $link);
						if (!$result)
						{
							failure("Nuke Fora Could not be retrieved.");
							exit();
						}
						success("Nuke Fora retrieved");
						message("Inserting fora and associated posts into Drupal now. This may take a while..");
						$counter = 1;
						while ($row = mysql_fetch_object($result))
						{
							$maxtid++;
							$row->forum_name = addslashes($row->forum_name);
							$row->forum_desc = addslashes($row->forum_desc);
							$forum_id = $row->forum_id;
							//message("Creating $row->forum_name forum in Drupal");
							$query = "INSERT INTO $d_term_data(tid, vid, name, description) ";
							$query .= "VALUES ('$maxtid', '$vid', '$row->forum_name', '$row->forum_desc')";
						        // alexis
						echo $query . '<br>';
							$result2 = mysql_query($query, $link);
							if (!$result2)
							{
								failure("Error transferring forum titles.. Exiting.. ");
								exit();
							}
							$counter++;
							success("Created '$row->forum_name' forum in Drupal");
							//Insert Container information into hierarchy table with parent
							$query = "INSERT INTO $d_term_hierarchy(tid, parent) ";
							$query .= "VALUES ('$maxtid', '$archive_id')";
							//message("Creating forum hierarchy for '$row->forum_name' forum in Drupal");
						        // alexis
						echo $query . '<br>';
							$result2 = mysql_query($query, $link);
							if (!$result2)
							{
								failure("Could not set forum hierarchy.");
								exit();
							}
							//success("Created forum hierarchy for '$row->forum_name' forum in Drupal.");
							//Select Posts
							$query = "SELECT $n_posts.topic_id AS tid, "; // $d_users.uid AS uid, $d_users.name AS name,";
							$query .= "$n_posts_text.post_subject AS title, $n_posts.poster_id, ";
							$query .= "$n_posts_text.post_text AS text, $n_posts.post_time AS time, $n_posts.poster_ip AS ip, $n_posts.post_username ";
							$query .= "FROM $n_posts_text, $n_posts "; //, $n_users, $d_users ";
							$query .= "WHERE $n_posts.post_id=$n_posts_text.post_id "; // AND $n_users.user_id=$n_posts.poster_id ";
							$query .= "AND $n_posts.forum_id='$forum_id' "; // AND ($d_users.name=$n_users.username) ";
							$query .= "ORDER BY $n_posts.topic_id, $n_posts.post_id";
							//message("Retrieving posts for $row->forum_name retrieved");
						        // alexis
						echo $query . '<br>';
							$result3 = mysql_query($query, $link);
							if ($result3)
							{
								//success("Posts for $row->forum_name retrieved");
								$maxnid = get_max_id("node_nid");
								$maxcid = get_max_id("comments_cid");
								$nid = $maxnid + 1;
								$cid = $maxcid + 1;
								//topic controls post threading
								$topic = -1;
while ($row = mysql_fetch_object($result3)) {

// get rid of funny session id BBCode characters from phpbb

$row->text = ereg_replace("\[(\/?[=\"0-9a-zA-Z]+):[a-zA-Z0-9]+\]","[\\1]", $row->text);
$row->text = ereg_replace("\[(\/?[=\"a-zA-Z]+):[a-zA-Z0-9]+(.*)\]","[\\1\\2]", $row->text);
$row->ip = get_ip($row->ip);

// look up the poster in phpnuke to find their real user name.(if available)

if ($row->poster_id != 1)  {
	
		// don't trust the username in the post.  Let's get the real thing.
		$query = "SELECT $n_users.username from $n_users WHERE user_id = '$row->poster_id'";
		message("Looking up phpnuke user # for $row->poster_id (aka $row->post_username )");
		echo $query . '<br>';
		$result6 = mysql_query($query, $link);   // I'm just gonna assume the query worked.  Forget looking for errors.
		$realname=mysql_fetch_object($result6);
		$row->name =$realname->username;
		
		// got the user's name alright.  Now look up drupal uid by name
		$myuser['name']=$row->name;
		if ($d_poster = user_load($myuser)) {
			 $row->uid=$d_poster->uid;}
			 	else {$row->uid=0; }
		}
		else   {		// it's anonymous!
	             $row->uid=0;
		      $row->name=$row->post_username;} 

echo "this post is by " . $row->name . ", who is Drupal user " . $row->uid  . "<br>" ;

if ($topic != $row->tid)   // it's a node -waldo	
{
$topic = $row->tid;
$tid = $maxtid;
$ptid = $nid;
$threadid = 0;
$counter++;
$ptitle = $row->title;

unset($mynode);
$mynode = new StdClass;

if ($row->uid==0) {$mynode->log=$row->name;}    // Drupal 6 will (apparently) be able to remember anonymous forum post names.
                                           //  So we're storing them in the log for now so we don't lose 'em.
$mynode->vid=$nid;
$mynode->title = $row->title;
$mynode->type=$node_ftype;
$mynode->uid = $row->uid;
$mynode->status=1;
$mynode->created = $row->time;
$mynode->changed = $row->time;
$mynode->comment=$comment;
$mynode->promote=0;
$mynode->body = tidyhtml($row->text); // or maybe mb_convert_encoding($row->text,"UTF-8","ISO-8859-1");  // may fix some character issues w/old MySQL dbs -W
//$mynode->teaser = tidyhtml($row->title);
$mynode->timestamp = $row->time;
$mynode->format = $forum_format;
print_r($mynode);
node_save($mynode);
	
if ($nid=$mynode->nid) { message("Forum node # $mynode->nid created.");} else {failure("Error inserting forum node $mynode->nid:");}

$query = "INSERT INTO $d_term_node(nid, tid) ";
$query .= "VALUES ($nid, $tid)";
message("Updating term_node table for post '$row->title' in Drupal (values: nid=$nid, tid=$tid)");
// alexis
echo $query . '<br>';
$result2 = mysql_query($query, $link);
if (!$result2)
{
failure("Updating term_node table failed. ".$counter." fora + posts transferred in total");
exit();
}

$query = "UPDATE $d_fora SET tid= '$tid' WHERE nid='$nid'";
message("Updating forum table in Drupal");
// alexis
echo $query . '<br>';
$result2 = mysql_query($query, $link);
if (!$result2) {
failure("Updating forum table Failed. ".$counter." fora + posts transferred in total");
exit();
}

// drupal will insert the current date as the changed date as as the last comment made.  We want the original date.  Fix that. --Waldo
$query4 = "UPDATE $d_nodes SET changed = " . $row->time . " WHERE nid=$nid"; echo $query4;  $result4=mysql_query($query4, $link); 
$query4 = "UPDATE $d_comment_statistics SET last_comment_timestamp = " . $row->time . " WHERE nid=$nid"; echo $query4; $result4=mysql_query($query4, $link);

}

else  //   it's a comment  -waldo
	{

		if (strlen($row->title) ==0) { $row->title = "Re: " . $mynode->title; }
	
		unset($mycomment);
		if ($row->uid == 0) {$user->name = $row->name;}  // for anonymous users -W

		$mycomment['nid']=$nid;
		$mycomment['uid']=$row->uid;
		$mycomment['subject'] = $row->title;
		$mycomment['comment'] = tidyhtml($row->text) ; // or maybe mb_convert_encoding($row->text,"UTF-8","ISO-8859-1");  // may fix some character issues w/old MySQL dbs -W
		$mycomment['hostname'] = $row->ip;
		$mycomment['timestamp'] = $row->time;
		$mycomment['format'] = $forum_format;
		$mycomment['users']=$comment_user_string;
		$mycomment['name']=$row->name;
		print_r($mycomment);
		echo "<p>saving comment from  " . $mycomment['name'] . " called " . $mycomment['subject'] . " (UID=" .$mycomment['uid']. ")";

		// drupal will insert the current date & hostname.  We want the original date/host.  Fix that. --Waldo
		if ($comid = comment_save($mycomment)) { $query4 = "UPDATE $d_comments SET timestamp = " . $row->time . ", hostname = '" .  $row->ip ."' WHERE cid=$comid"; echo $query4;  $result4=mysql_query($query4, $link); 
					    $query4 = "UPDATE $d_comment_statistics SET last_comment_timestamp = " . $row->time . " WHERE nid=$nid AND comment_count >0"; echo $query4; $result4=mysql_query($query4, $link);}
					    else {failure("Couldn't add the comment.");}
		} 
}

}
else	{
		failure("MySQL error. Nuke Posts could not be retrieved.");
		exit();
	}
}
set_max_id("term_data_tid", $maxtid);
success($counter." fora + posts transferred successfully!");
echo "<div class='options'>";
echo "<a href='{$_SERVER['PHP_SELF']}?section=polls'>Migrate Polls?</a>";
echo "&nbsp;<a href='{$_SERVER['PHP_SELF']}'>Back To Main?</a>";
echo "</div>";
break;



//////////////////////////////////////////////////////////////////////////////////////////





					default:
						heading("Overview");
						Message("Version:  $version");
						if ($connected)
						{
							$query = "SELECT COUNT(*) AS usernum FROM $n_users";
						        // alexis
						        // echo $query;
							$result = mysql_query($query, $link);
							if ($row = mysql_fetch_object($result))
							{
								$usernum_n = $row->usernum;
							}
							$query = "SELECT COUNT(*) AS usernum FROM $d_users";
						        // alexis
							// echo $query . '<br>';
							$result = mysql_query($query, $link);
							if ($row = mysql_fetch_object($result))
							{
								$usernum_d = $row->usernum;
							}
							$query = "SELECT COUNT(*) AS storynum FROM $n_stories";
						        // alexis
							// echo $query . '<br>';
							$result = mysql_query($query, $link);
							if ($row = mysql_fetch_object($result))
							{
								$storynum = $row->storynum;
							}
						}
						echo "<p class='important'>";
						echo "Use this script at YOUR OWN RISK. No guarantees provided etc. etc. I have also not streamlined any of the SQL queries, as ";
						echo "that wasn't really high on my priority list :P </p>";  //amen to that --Waldo
						echo "<ul><li>This is a migration script to move <em>only</em> users, stories, story categories, fora, polls, and their comments from the <a href='http://phpnuke.org/'>PHP-Nuke</a> CMS to the <a href='http://www.drupal.org'>Drupal</a> CMS. ";
						echo "It should also convert *anonymous* user's comments and postings provided you have enabled anonymous users to post and comment in the Authorization section of Drupal. This is ";
						echo "highly advised if you ever allowed anonymous users to post in phpnuke.  Otherwise... strange things may occur when you import, such as comments from registered ";
						echo "uses appearing without that comment's anonymously-posted parent message.";
						echo "<li>";
						echo "It is assumed that you are using MySQL for your database.  If you're using something else (ie, postgres), you'll need to either switch your database to mysql or modify this script.";
						echo "</li>";
						echo "<li>";
						echo "Some things this script will <span class='important'>NOT</span> do:";
						echo "<ul>";
						echo "<li>Will not migrate personal information of users. It migrates only the username, password and email address.";
						echo "</li>";
						echo "<li>";
						echo "The main fora are transferred over as a lump. You can reorganise them in Drupal quite easily.";
						echo "</li>";
						echo "<li>";
						echo "Filters slightly, but will not remove BBCode tags from forum posts.  Be sure to load and install the <a href=\"http://drupal.org/project/bbcode\">BBCode</a> module as described below.";
						echo "</li>";
						echo "<li>";
						echo "If nuke forum replies are missing titles, titles called \"Re: title of the parent post\" is used.";
						echo "</li>";
						echo "<li>";
						echo "If you have the \"Tidy\" extensions installed in php5, most user HTML input will be cleaned up so that all HTML tags are closed properly (among other fixes).";
						echo "</li>";
						echo "<li>";
						echo "If your msqyl database was set up a long time ago, the text may still be encoded using the Latin1 character set.  Drupal uses the UTF8 character set.  Which means that some characters";
						echo " may not translate correctly, especially non-Latin ones.  You will have to do some Googling to determine the best way to do the character conversions.  Newer versions of mysql ";
						echo " use UTF8 by default, so this may not be an issue for you.";
						echo "</li>";
						echo "<li>";
						echo "Besides users, stories, story categories, fora, polls, and associated comments, nothing else is migrated.";
						echo "</li>";
						echo "</ul>";

						echo "<li>";
						echo "This has been tested <em>only</em> with migrating a security-patched site running PHP-Nuke 6.5 to a fresh installation of Drupal 5.1.  <span class='important'>If you are using another version ";
						echo " of PHP-Nuke, you may need to modify the script as some of the database field names have changed slightly (user_id -> uid and that kind of thing)</span>";
						echo "</li>";
						echo "<li>";
						echo "Best way to do this migration:";
						echo "<ol>";
						echo "<li class='important'>";
						echo "BACK UP everything.  Especially your databases.  This script comes with zero guarantees or warrantees and may cause unintended damage!!! ";
						echo "</li>";
						echo "<li>";
						echo "IF YOU HAVE AN EXISTING DRUPAL 5.x SERVER GOING, make a local working copy of your existing drupal installation. Note that this script has NOT been tested with an existing drupal instance, only a fresh installation of 5.0 and 5.1, so good luck :)";
						echo "</li>";
						echo "<li>";
						echo "IF YOU ARE STARTING FRESH, create a local working installation of Drupal 5.x, then create your administrator account (user with uid =1, ie, the first user you create).";
						echo "</li>";
						echo "<li>";
						echo "Add the <a href=\"http://drupal.org/project/bbcode\">BBCode module</a> so that new forum postings will be interpreted by BBCode. ";
						echo "To do this, download and place the module in its appropriate location, then enable it via Administration->Modules.  Next, ";
						echo "go to Administration->Site Configuration->Input Formats, and under Filtered HTML, choose Configure.  Then tick the box for BBCode.";  
						echo "</li>";
						echo "<li>";
						echo "Be sure to enable the Poll and Forum modules too.";
						echo "</li>";
						echo "<li>";
						echo "If you want a decent chance of anonymous comments migrating properly, you must go under Administer->Access Control and then just turn on everything for Anonymous Users.  Posting comments, Stories, forum, the works.";
						echo " All \"without approval\".  Otherwise only existing Drupal users' comments will appear. Just enable everything for now, and when you're all done with the migration, you can set it the way you'd like it to be.";
						echo " So just do it.";
						echo "</li>";
						echo "<li>";
						echo "Add a test story.";
						echo "</li>";
						echo "<li>";
						echo "Add a test reply to the story.";
						echo "</li>";
						echo "<li>";
						echo "Add a test forum.";
						echo "</li>";
						echo "<li>";
						echo "Add a test post to the above forum.";
						echo "</li>";
						echo "<li>";
						echo "Add a test comment to the above forum post.";
						echo "</li>";
						echo "<li>";
						echo "Even if you are already using an existing Drupal installation, make sure that all the above steps are performed.";
						echo "</li>";
						echo "<li>";
						echo "Everything works correctly?  Next, create another mysql database and dump the PHP-Nuke database in it.";
						echo "</li>";
						echo "<li>";
						echo "If your administrator account in Drupal is named the same as an account in the PHP-Nuke database, add the account's username to ";
						echo " the \$user_array variable in this PHP file's config settings.";
						echo "</li>";
						echo "<li>";
						echo "Next, if you haven't already, edit the other configuration stuff at the top of this script (so, for example, it can find and access your mysql database and verify that this script is in your base Drupal directory (local version)).";
						echo "</li>";
						echo "<li>";
						echo "Run this script and click the options at the bottom of the screen to migrate in order (users, stories, fora, then polls).  Debugging information may scroll down the screen. <span class='important'>Do not stop the script in mid-execution.</span>";
						echo "</li>";
						echo "<li>";
						echo "Depending on how large your phpnuke site was, it may take a while to complete the scripts.  For example, converting my phpnuke fora ";
						echo "(14 fora, 11,000 post and maybe 10,000 comments) took over 1/2 hour. ";
						echo "This script is not optimized for efficiency or speed.  If the script times out or you get errors relating to memory usage, you may need to adjust PHP's settings. ";
						echo "Refer to the variables \"memory_limit\" and \"max_execution_time\" in your php.ini configuration file.  Set to something really big. ";
						echo "</li>";
						echo "<li>";
						echo "If something should screw up in the script, restore the Drupal database to the backup version, then edit this script, seeing if you can figure out the problem.  Then try again.";
						echo " <span class='important'>It's important to restore the Drupal database to an unmodified, unmigrated version before trying again, as a half-migrated database is possibly corrupted.</span>";
						echo "</li>";
						echo "<li>";
						echo "Once everything is finished, test the local copy of Drupal to ensure that everything is A-OK.  Re-adjust your anonymous users' access to posting and commenting.";
						echo " Don't forget to thoroughly test your migrated Drupal system before putting it on a \"live\" server.";
						echo "</li>";
						echo "<li>";
						echo "If you're convinced your local installation has properly migrated and eveyrthing's working, replace the Drupal database on the server with this updated one.   Also don't forget to copy the BBCode module up to the server.  Then back up the freshly migrated site in case you find anything wrong later and need to go back.";
						echo "</li>";
						echo "</ol>";
						echo "</ul>";
						echo "<p />";
						echo "If you are ready, click on the 'Migrate Users' link at the bottom. If you get stuck at any point or run into errors, ask for help <a href=\"http://drupal.org/node/498\">on the drupal site</a>.";
						echo "<p class='important'>In case you missed it-- BACK UP everything before proceeding.  BACK UP everything <i>after</i> proceeding.  In short, BACK UP, BACK UP, BACK UP!  ";
						echo "This is still experimental software, and remember, stopping the script in mid-migration will probably leave your database unusable.</p>";
						echo "<p /><ul>";
						if ($connected)
						{
							echo "<li>";
							echo "There are $usernum_n users and $storynum stories in the PHP-Nuke database.";
							echo "</li>";
							echo "<li>";
							echo "Currently, there are $usernum_d users in the Drupal database.";
							echo "</li>";
						}
						echo "</ul>";
						if ($connected)
						{
							echo "<div class='options'>";
							echo "<a href='{$_SERVER['PHP_SELF']}?section=users'>Migrate Users?</a>";
							echo "</div>";
						}
						break;
						
//////////////////////////////////////////////////////////////////////////////////////////
						
				}
				if ($connected)	mysql_close($link);
			?>
		</div>
	</body>
</html>
